import * as _jitl_quickjs_ffi_types from '@jitl/quickjs-ffi-types';
import { EmscriptenModuleLoader, QuickJSEmscriptenModule } from '@jitl/quickjs-ffi-types';
import { QuickJSFFI } from './ffi.js';

// Generated from ../../templates/emscripten-module.SYNC.d.ts

/**
 *  Emscripten module built from the unmodified [`quickjs/quickjs.h`](../quickjs/quickjs.h)
 *  and our FFI support functions [c/interface.c](../c/interface.c).
 *
 * Note that emscripten modules returned by a `MODULARIZE=1` emscripten build
 * (like this one) load asynchronously.
 */
declare const ModuleLoader: EmscriptenModuleLoader<QuickJSEmscriptenModule>

declare namespace ___dist_emscripten_module_js {
  export { ModuleLoader as default };
}

/**
 * This export is a variant of the quickjs WASM library:
 * ### [@jitl/quickjs-singlefile-mjs-debug-sync](https://github.com/justjake/quickjs-emscripten/blob/main/doc/packages/@jitl/quickjs-singlefile-mjs-debug-sync/README.md)
 *
 * Variant with the WASM data embedded into a NodeJS ESModule.
 *
 * | Variable            |    Setting                     |    Description    |
 * | --                  | --                             | --                |
 * | releaseMode         | debug         | Enables assertions and memory sanitizers. Try to run your tests against debug variants, in addition to your preferred production variant, to catch more bugs. |
 * | syncMode            | sync            | The default, normal build. Note that both variants support regular async functions. |
 * | emscriptenInclusion | singlefile | The WASM runtime is included directly in the JS file. Use if you run into issues with missing .wasm files when building or deploying your app. |
 * | exports             | import                  | Has these package.json export conditions |
 *
 */
declare const variant: {
    readonly type: "sync";
    readonly importFFI: () => Promise<typeof QuickJSFFI | (new (module: _jitl_quickjs_ffi_types.QuickJSEmscriptenModule) => _jitl_quickjs_ffi_types.QuickJSFFI)>;
    readonly importModuleLoader: () => Promise<typeof ___dist_emscripten_module_js | _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSEmscriptenModule> | {
        default: _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSEmscriptenModule>;
    } | {
        default: {
            default: _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSEmscriptenModule>;
        };
    }>;
};

export { variant as default };
